100 REMark ***********************************************************
110 REMark *
120 REMark *                    BOUQLDER QLASH
130 REMark *                    ==============
140 REMark *
150 REMark *        Sbasic portion
160 REMark *        (Commented version)
170 REMark *
180 REMark *        Code and documentation (C) W. Lenerz 2018
190 REMark *
200 REMark ***********************************************************
210 :
220 start_game
230 :
240 REMark ------------------------------------------------------------
250 REMark
260 REMark  Initialisation
270 REMark
280 REMark ------------------------------------------------------------
290 :
300 DEFine PROCedure init
310 REMark variables starting with cv_ are global variables
320 REMark cv_data$,cv_data%= string/ integer representation of a cave
330 REMark cv_rf%(2) = rockford position (y,x)
340 REMark cv_gamechan%= main game channel
350 REMark cv_spxsz%,cv_spysz% = xsize,ysize of one square (and sprite)
360 LOCal f$,row%,col%,lp%,a$,fake%(2,2),llen,sound_addr,temp
370   cv_scr_xlim%=SCR_XLIM
380   cv_scr_ylim%=SCR_YLIM
390   cv_no_eye_candy%=0
400  REMark   cv_scr_xlim%=512
410  REMark  cv_scr_ylim%=384
420   IF DISP_TYPE< 16 OR cv_scr_xlim%<512 OR cv_scr_ylim%<384
430     PRINT "Sorry, but this game needs a screen of at least 512x384 pixels in at least 256 colours!"
440     STOP
450   END IF
460   CLCHP
470   cv_timer_addr=0
480   timer_start
490   IF MACHINE=17:POKE HEX('FF00002C'),1  : REMark 20 KHz sound
500   COLOUR_PAL
510   cv_gamechan%=3
520   OPEN#cv_gamechan%+1,"con"
530   WINDOW#cv_gamechan%+1,cv_scr_xlim%,cv_scr_ylim%,0,0
540   temp=BD_SNDF (MACHINE, HOME_DIR$&"snd_thunder_ub")
550   CLS#cv_gamechan%+1                    : REMark make entire screen black
560   OPEN#cv_gamechan%,"con"
570   col%=0:row%=0
580   cv_spxsz%=16:cv_spysz%=16
590   cv_winysz%=23*cv_spysz%
600   cv_col_start%=0
610   cv_col_end%=(cv_scr_xlim% DIV cv_spxsz%) -1                        : REMark both start at 0
620   IF cv_col_end%>39:cv_col_end%=39
630   IF DISP_TYPE=16 AND cv_col_end%<39:cv_col_end%=(cv_col_end% DIV 2) * 2 : REMark make even!
640   cv_winxsz%=(cv_col_end%+1)*cv_spxsz%
650   greeting
660   AT#cv_gamechan%, row%,col%:PRINT#cv_gamechan%, "Loading sprites... 1"
670   f$= HOME_DIR$&"img_sprites_w_bin"
680   cv_sprt_white =ALCHP(FLEN(\f$))     : REMark space for sprites
690   LBYTES f$,cv_sprt_white
700   AT#cv_gamechan%, row%,col%:PRINT#cv_gamechan%, "Loading sprites... 2"
710   f$= HOME_DIR$&"img_sprites_y_bin"
720   cv_sprt_yellow =ALCHP(FLEN(\f$))
730   LBYTES f$,cv_sprt_yellow
740   AT#cv_gamechan%, row%,col%:PRINT#cv_gamechan%, "Loading sprites... 3"
750   row%=row%+1
760   cv_madd=ALCHP(280)
770   f$= HOME_DIR$&"img_sprites"&DISP_TYPE
780   llen=FLEN(\f$)          : REMark space for sprites - leave the +2!!!!!
790   cv_sprt_addr=ALCHP(llen*2 +2)         : REMark space for sprites - leave the +2!!!!!
800   LBYTES f$,cv_sprt_addr+2              : REMark leave the +2!!!!(see bdd_draw_asm)
810   LBYTES f$,cv_sprt_addr+2+llen         : REMark keep one copy of orig
820   AT#cv_gamechan%, row%,col%:PRINT#cv_gamechan%, "Calibrating..."
830   POKE_W cv_madd+98,checkHz%            : REMark x nbr of ticks so that 10x = 1 sec
840   row%=row%+1
850   AT#cv_gamechan%, row%,col%:PRINT#cv_gamechan%, "Loading sounds..."
860   row%=row%+1
870   f$= HOME_DIR$&"snd_sounds"
880   sound_addr=ALCHP(FLEN(\f$))
890   LBYTES f$,sound_addr
900   row%=row%-4
910   AT #cv_gamechan%,row%,0:CLS #cv_gamechan%,3:CLS #cv_gamechan%,2
920   INK#cv_gamechan%,7
930   row%=row%+1
940   AT#cv_gamechan%, row%,col%:PRINT#cv_gamechan%, "Hit any key to continue, or"
950   row%=row%+1
960   AT#cv_gamechan%, row%,col%:PRINT#cv_gamechan%, "ESC to quit ..."
970   arr_spce=ALCHP(2110)                  : REMark space for data for one cave
980   lp%=(cv_col_end% -21) DIV 3
990   POKE_W cv_madd+90,2                   : REMark "diamonds required" status bar column
1000   POKE_W cv_madd+88,2+9+lp%*2                  : REMark time remaining column
1010   POKE_W cv_madd+92,2+5+lp%                  : REMark nbr of diams got column
1020   POKE_W cv_madd+94,cv_col_end%-7                  : REMark score column
1030   set_wdw 0
1040   BD_INIT cv_madd,cv_sprt_addr,cv_sprt_white, cv_sprt_yellow,cv_spxsz%,cv_spysz%,(65536*MACHINE)+cv_gamechan%,sound_addr,arr_spce,DISP_TYPE
1050   IF cv_no_eye_candy%:RETurn
1060   a$=INKEY$(#cv_gamechan%,100)
1070   IF a$=""
1080     REPeat lp%
1090       BD_SOUND cv_madd,11
1100       a$=title_wave$:IF a$<>"":EXIT lp% : REMark play around with the title a little
1110       WAIT 20
1120     END REPeat lp%
1130   END IF
1140   IF a$=CHR$ (27):stop_game
1150 END DEFine init
1160 :
1170 DEFine PROCedure greeting
1180 REMark show loading progress
1190 REMark row%,col% are from caller
1200   LOCal addr
1210   row%=(cv_scr_ylim%-176) DIV 2
1220   col%=(cv_scr_xlim% -352) DIV 2
1230   IF row% MOD 2<>0:row%=row%+1
1240   IF col% MOD 2<>0:col%=col%+1
1250   addr=ALCHP(FLEN(\HOME_DIR$&"img_title_spr"))
1260   LBYTES HOME_DIR$&"img_title_spr",addr
1270   WSPRT #cv_gamechan%+1,col%,row%,addr
1280   row%=row%+(cv_spysz% *4)
1290   col%=col%+cv_spxsz%
1300   WINDOW#cv_gamechan%,cv_spxsz%*20,cv_spysz%*6,col%,row%
1310   startx%=col%+2*cv_spxsz%:starty%=row%-2*cv_spysz%
1320   row%=2:col%=10
1330   RECHP addr
1340 END DEFine greeting
1350 :
1360 REMark ------------------------------------------------------------
1370 REMark
1380 REMark  Reading in a game file
1390 REMark
1400 REMark ------------------------------------------------------------
1410 :
1420 DEFine FuNction read_data_file%(file$)
1430 LOCal sz,nmf$,descrs$
1440    sz=FLEN(\file$)
1450    cv_nbr_caves%=((sz-22)/(50*42))-1    : REMark file size-header length 2*rows*col
1460    DIM cv_data%(cv_nbr_caves%,24,41)
1470    LAR file$,cv_data%
1480    sz=LEN(file$)-4
1490    DIM cv_cave_names$(cv_nbr_caves%,40)
1500    LAR file$(1 TO sz)&"_nmf",cv_cave_names$
1510    DIM cv_cave_descrs$(cv_nbr_caves%,80)
1520    LAR file$(1 TO sz)&"_dsf",cv_cave_descrs$
1530    RETurn 1
1540 END DEFine read_data_file%
1550 :
1560 REMark -------------------------------------------------------------
1570 REMark
1580 REMark  Game and cave selection
1590 REMark
1600 REMark -------------------------------------------------------------
1610 :
1620 DEFine FuNction get_game$
1630 REMark get the name of a game file
1640 LOCal fake%(2,2),col%,a$,sz%
1650   a$="Choose your game"
1660   sz%=(LEN(a$)+6)*16                    : REMark a$ + 2 diamonds at each end + space
1670   set_wdw 2
1680   cv_games%=get_game_files%
1690   col%=((cv_xs%-sz%) DIV 2) DIV cv_spxsz%
1700   BD_PRINT cv_madd,cv_sprt_yellow,2*65536+col%,CHR$(64)&CHR$(64)
1710   col%=col%+3
1720   BD_PRINT cv_madd,cv_sprt_white,2*65536+col%,a$
1730   col%=col%+1+LEN(a$)
1740   BD_PRINT cv_madd,cv_sprt_yellow,2*65536+col%,CHR$(64)&CHR$(64)
1750   sz%=23*16
1760   col%=((cv_xs%-sz%) DIV 2) DIV cv_spxsz%
1770   a$="or hit"
1780   BD_PRINT cv_madd,cv_sprt_white,4*65536+col%,a$
1790   col%=col%+1+LEN(a$)
1800   BD_PRINT cv_madd,cv_sprt_yellow,4*65536+col%,"ESC"
1810   col%=col%+4
1820   BD_PRINT cv_madd,cv_sprt_white,4*65536+col%,"to quit game"
1830   a$=get_menu_choice$(cv_caves$,cv_games%-1,5,3,1)
1840   IF a$=CHR$(27)OR a$="":RETurn CHR$(27)
1850   RETurn HOME_DIR$&"lvl_"&a$&"_wlf"
1860 END DEFine get_game$
1870 :
1880 DEFine FuNction get_game_files%
1890 REMark puts the name of all playable game files in the "lvl" subdir into cv_caves$
1900 LOCal lp%,chan%,a$,count%,maxcaves%,hdir_len%,nm_len%,tempfile$
1910   maxcaves%=100
1920   DIM cv_caves$(maxcaves%,46)
1930   tempfile$="ram1_xxybqlashyxx_caves"
1940   chan%=FOP_OVER(tempfile$)
1950   DIR#chan%,HOME_DIR$&"lvl"
1960   hdir_len%=LEN(HOME_DIR$)
1970   PRINT#chan%
1980   GET#chan%\0
1990   INPUT#chan%,a$
2000   INPUT#chan%,a$
2010   count%=0
2020   REPeat lp%
2030     IF EOF(#chan%):EXIT lp%
2040     INPUT#chan%,a$
2050     nm_len%=LEN(a$)
2060     IF nm_len%=0:EXIT lp%
2070     IF a$(nm_len%-3 TO) =="_wlf"
2080       cv_caves$(count%)=a$(hdir_len% TO nm_len%-4)
2090       count%=count%+1
2100       IF count%=maxcaves%:EXIT lp%
2110     END IF
2120   END REPeat lp%
2130   CLOSE#chan%
2140   QSORTF cv_caves$,0,0
2150   DELETE tempfile$
2160   RETurn count%
2170 END DEFine get_game_files%
2180 :
2190 DEFine FuNction get_cave%
2200 REMark gets the number of a cave from a menu choice showing all caves of a game
2210 LOCal fake%(2,2),col%,a$,sz%
2220   a$="Choose your cave"
2230   sz%=(LEN(a$)+6)*16                    : REMark a$ + 2 diamonds at each end + space
2240   set_wdw 2
2250   col%=((cv_xs%-sz%) DIV 2) DIV cv_spxsz%
2260   BD_PRINT cv_madd,cv_sprt_yellow,2*65536+col%,CHR$(64)&CHR$(64)
2270   col%=col%+3
2280   BD_PRINT cv_madd,cv_sprt_white,2*65536+col%,a$
2290   col%=col%+1+LEN(a$)
2300   BD_PRINT cv_madd,cv_sprt_yellow,2*65536+col%,CHR$(64)&CHR$(64)
2310   sz%=21*16
2320   col%=((cv_xs%-sz%) DIV 2) DIV cv_spxsz%
2330   a$="or hit"
2340   BD_PRINT cv_madd,cv_sprt_white,4*65536+col%,a$
2350   col%=col%+1+LEN(a$)
2360   BD_PRINT cv_madd,cv_sprt_yellow,4*65536+col%,"ESC"
2370   col%=col%+4
2380   BD_PRINT cv_madd,cv_sprt_white,4*65536+col%,"to go back"
2390   a$=get_menu_choice$(cv_cave_names$,cv_nbr_caves%,5,30,22)
2400   IF a$="":RETurn -1
2410   IF cv_nbr_caves%=0:RETurn 0
2420   IF cv_nbr_caves%=1:RETurn NOT (cv_cave_names$(0)==a$)
2430   FOR col%=0 TO cv_nbr_caves%
2440     IF cv_cave_names$(col%)==a$:RETurn col%
2450   END FOR col%
2460   RETurn -1
2470 END DEFine get_cave%
2480 :
2490 REMark -------------------------------------------------------------
2500 REMark
2510 REMark  Main gameplay
2520 REMark
2530 REMark -------------------------------------------------------------
2540 :
2550 DEFine PROCedure start_game
2560 REMark initial start of the game
2570 LOCal res%,a$,lp%,lp1%
2580   init
2590   res%=-1
2600   REPeat lp%
2610     wait_no_key_down
2620     IF res%= -1
2630       a$=get_game$                      : REMark let user choose a game file
2640       IF a$=CHR$(27):stop_game          : REMark user hit escape,is done
2650       res%=read_data_file%(a$)          : REMark read this games file
2660       IF res%<0:STOP                    : REMark real big oops
2670     END IF
2680     cv_current_cave%=get_cave%          : REMark let user choose the cave to play
2690     IF cv_current_cave%==-1:res%=-1:NEXT lp% : REMark user hit esc to go back
2700     set_wdw 1
2710     res% = run_cave%(cv_current_cave%)
2720   END REPeat lp%
2730 END DEFine start_game
2740 :
2750 DEFine FuNction run_cave% (cv_current_cave%)
2760 REMark this is the main game loop
2770 LOCal res%,lp%,a$,temp%,interval%
2780   REPeat lp%
2790     wait_no_key_down
2800     set_wdw 0
2810     CLS#cv_gamechan%
2820     cv_col_start%=0
2830     cv_col_end%=(cv_scr_xlim% DIV cv_spxsz%) -1                        : REMark both start at 0
2840     IF cv_col_end% > 39:cv_col_end%=39
2850     IF DISP_TYPE=16 AND cv_col_end%<39:cv_col_end%=(cv_col_end% DIV 2) * 2 : REMark make even!
2860     temp%= cv_data%(cv_current_cave%,24,4)-1
2870     IF temp%>cv_col_end%
2880        temp%=39-cv_col_end%
2890        cv_col_end%=39
2900        cv_col_start%=cv_col_start%+temp%
2910     END IF
2920     cv_data%(cv_current_cave%,24,16) = cv_col_start%
2930     cv_data%(cv_current_cave%,24,17) = cv_col_end%
2940     BD_CAVE cv_madd,cv_timer_addr,cv_data%(cv_current_cave%)
2950     IF cv_no_eye_candy%
2960       set_wdw 0
2970       BD_DRAW cv_madd                     : REMark draw initial cave
2980     ELSE
2990       anim_open cv_current_cave%
3000       BD_STATUS cv_madd
3010     END IF
3020     wait_no_key_down
3030     res%= BD_SCAN (cv_madd)
3040     PAUSE 5
3050     SELect ON res%
3060        = -1 : a$=you_lost$              : REMark RIP, get user choice
3070               IF a$=="y":NEXT lp%       : REMark user plays same cave again
3080               RETurn -2                 : REMark let user select another cave
3090        =  8 : RETurn -2                 : REMark user hit ESC, go back to selection
3100        =  1 : cv_current_cave%= cv_current_cave%+1 : REMark ENTER hit - try next cave
3110               IF cv_current_cave%>cv_nbr_caves%:cv_current_cave%=cv_nbr_caves%:BEEP 4000,250
3120        =  2 : PAUSE 5 :a$=you_won$ (43,7)
3130               IF a$=="y"
3140                 cv_current_cave%= cv_current_cave%+1 : REMark ENTER hit - try next cave
3150                 IF cv_current_cave%>cv_nbr_caves%
3160                    cv_current_cave%=cv_nbr_caves%
3170                    RETurn -1
3180                 ELSE
3190                   NEXT lp%
3200                 END IF
3210               ELSE
3220                 RETurn -1
3230               END IF
3240        = 65 : cv_current_cave%= cv_current_cave%-1 : REMark space + enter hit - try previous cave
3250               IF cv_current_cave%<0:cv_current_cave%=0:BEEP 4000,250
3260     END SELect
3270   END REPeat lp%
3280 END DEFine run_cave%
3290 :
3300 DEFine PROCedure stop_game
3310   timer_stop
3320   CLOSE#cv_gamechan%
3330   CLOSE#cv_gamechan%+1
3340   QUIT
3350 END DEFine stop_game
3360 :
3370 REMark ----------------------------------------------------
3380 REMark
3390 REMark Winning/losing screens
3400 REMark
3410 REMark ----------------------------------------------------
3420 :
3430 DEFine FuNction you_lost$
3440 LOCal lp%,tone%,xo%,yo%,a$,b$,colo%,sz%,intv%
3450   IF cv_no_eye_candy%:RETurn "n"
3460   set_wdw 2
3470   CSIZE#cv_gamechan%,3,1
3480   COLOUR_PAL
3490   xo%=(cv_xs%-8*16) DIV 2
3500   yo%=50
3510   a$="YOU LOST"
3520   CURSOR#cv_gamechan%,xo%,yo%:PRINT #cv_gamechan%,a$
3530   tone%=10
3540   BEEP 2100,tone%
3550   REPeat lp%:IF INKEY$(#cv_gamechan%)="":EXIT lp%
3560   PAPER#cv_gamechan%,0
3570   CLS#cv_gamechan%
3580   INK#cv_gamechan%,37
3590   OVER#cv_gamechan%,1
3600   xo%=(cv_xs%-8*16) DIV 2  -25
3610   tone%=tone%+10
3620   FOR lp%=1 TO 49
3630     CURSOR#cv_gamechan%,xo%+lp%,yo%+lp%:PRINT #cv_gamechan%,a$
3640     WAIT 1
3650     b$=INKEY$(#cv_gamechan%)
3660     IF (lp% MOD 7) =0
3670       BEEP 2100,tone%
3680       tone%=tone%+10
3690     END IF
3700   END FOR lp%
3710   INK#cv_gamechan%,0
3720   FOR lp%=1 TO 44
3730     CURSOR#cv_gamechan%,xo%+lp%,yo%+lp%:PRINT #cv_gamechan%,a$
3740     WAIT 1
3750     b$=INKEY$(#cv_gamechan%)
3760     IF (lp% MOD 7) =0
3770       BEEP 2100,tone%
3780       tone%=tone%+10
3790     END IF
3800   END FOR lp%
3810   WAIT 5
3820   BEEP 10000,160
3830   WAIT 17
3840   OVER#cv_gamechan%,0
3850   INK#cv_gamechan%,2
3860   CLS#cv_gamechan%
3870   xo%=xo%+49:yo%=yo%+49
3880   CURSOR#cv_gamechan%,xo%,yo%:PRINT# cv_gamechan%;a$
3890   a$="Play this cave again? (y/n)"
3900   CSIZE#cv_gamechan%,1,0
3910   INK#cv_gamechan%,3
3920   CURSOR#cv_gamechan%,(cv_xs%-LEN(a$)*6) DIV 2,yo%+50:PRINT# cv_gamechan%;a$
3930   INK#cv_gamechan%,2
3940   tone%=-1
3950   CSIZE#cv_gamechan%,3,1
3960   a$="YOU LOST"
3970   colo%=2
3980   sz%=cv_xs%-LEN(a$)*16-10
3990   intv%=0
4000   REPeat lp%
4010     xo%=xo%+tone%
4020     IF xo%<10:tone%=1
4030     IF xo%>sz%:tone%=-1
4040     intv%=intv%+1
4050     IF (intv% MOD 10) = 0
4060       colo%=colo%+1:IF colo%=256:colo%=1
4070       INK#cv_gamechan%,colo%
4080       intv%=0
4090     END IF
4100     CURSOR#cv_gamechan%,xo%,yo%:PRINT# cv_gamechan%;a$
4110     b$=INKEY$(#cv_gamechan%,2)
4120     IF b$<>"":RETurn b$
4130   END REPeat lp%
4140 END DEFine you_lost$
4150 :
4160 DEFine FuNction you_won$  (inkk%, inkend%)
4170 LOCal dist%,yo%,xo%,xo2%,a$,llen%,iters%,temp%,lp%
4180   set_wdw 2
4190   IF cv_no_eye_candy%:RETurn "y"  : REMark goto next cave immdiately
4200   CSIZE#cv_gamechan%,3,1
4210   OVER#cv_gamechan%,1
4220   a$="CAVE FINISHED!"
4230   llen%=LEN(a$)*16
4240   temp%=cv_xs% DIV 2
4250   iters%=124
4260   xo%=temp%-(llen% DIV 2)-iters%
4270   xo2%=temp%-(llen% DIV 2)+iters%
4280   yo%=cv_ys% DIV 2
4290   FOR lp%=0 TO iters% STEP 2
4300     IF (lp% MOD 10)=0
4310       BEEP 3000,150-lp%
4320     END IF
4330     INK#cv_gamechan%,inkk%
4340     CURSOR#cv_gamechan%,xo%+lp%,yo%
4350     PRINT#cv_gamechan%,a$;
4360     CURSOR#cv_gamechan%,xo2%-lp%,yo%
4370     PRINT#cv_gamechan%,a$
4380     CLS#cv_gamechan%,4
4390     IF lp%=iters%:EXIT lp%
4400     WAIT 1
4410     INK#cv_gamechan%,0
4420     CURSOR#cv_gamechan%,xo%+lp%,yo%
4430     PRINT#cv_gamechan%,a$;
4440     CURSOR#cv_gamechan%,xo2%-lp%,yo%
4450     PRINT#cv_gamechan%,a$
4460   END FOR lp%
4470   CURSOR#cv_gamechan%,xo%+lp%,yo%
4480   INK #cv_gamechan%,inkend%
4490   WAIT 10
4500 RETurn "y"
4510   PRINT#cv_gamechan%,a$
4520   b$="Go to next cave? (y/n)"
4530   temp%=LEN(b$)*6
4540   temp%=(cv_xs%-temp%)DIV 2
4550   CURSOR#cv_gamechan%,temp%,cv_ys%-80
4560   CSIZE#cv_gamechan%,0,0
4570   INK #cv_gamechan%,208
4580   PRINT#cv_gamechan%,b$
4590   temp%=lp%-6
4600   CSIZE#cv_gamechan%,3,1
4610   REPeat lp%
4620     b$=INKEY$(#cv_gamechan%,30)
4630     IF b$<>"" AND b$ INSTR "yn":RETurn b$
4640     BLOCK#cv_gamechan%,llen%+12,40,xo%+temp%,yo%-10,inkend%
4650     CURSOR#cv_gamechan%,xo%+6+temp%,yo%
4660     INK #cv_gamechan%,0
4670     PRINT#cv_gamechan%,a$;
4680     b$=INKEY$(#cv_gamechan%,30)
4690     IF b$>"" AND b$ INSTR "yn":RETurn b$
4700     BLOCK#cv_gamechan%,llen%+12,40,xo%+temp%,yo%-10,0
4710     CURSOR#cv_gamechan%,xo%+temp%+6,yo%
4720     INK #cv_gamechan%,inkend%
4730     PRINT#cv_gamechan%,a$;
4740   END REPeat lp%
4750 END DEFine you_won$
4760 :
4770 REMark -------------------------------------------------------------
4780 REMark
4790 REMark  Eye candy
4800 REMark
4810 REMark -------------------------------------------------------------
4820 :
4830 DEFine FuNction title_wave$
4840 REMark make the title "wave", exit when key pressed and return key pressed
4850 LOCal pos%(14),dir%(14),lp%,start_x%,start_y%,a$,incr%
4860   incr%=3
4870   start_y%=starty%
4880   FOR lp%=1 TO DIMN(dir%,1):dir%(lp%)=-incr%
4890   FOR lp%=0 TO DIMN(pos%,1)-1
4900      pos%(lp%+1)=lp%*incr%
4910   END FOR lp%
4920   FOR lp%=1 TO 9+DIMN(pos%,1)
4930     start_x%=startx%
4940     move_title pos%,dir%
4950     a$=INKEY$(#cv_gamechan%,2)
4960     IF a$<>"":RETurn a$
4970   END FOR lp%
4980   RETurn ""
4990 END DEFine title_wave$
5000 :
5010 DEFine PROCedure move_title (pos%,dir%)
5020 REMark set wdw to each title char in turn, move the title "chars" up and down
5030 REMark by scrolling wdw up/down
5040 LOCal lp%, new_pos%
5050   FOR lp%=1 TO DIMN(pos%,1)
5060     IF pos%(lp%)=-incr% AND dir%(lp%)=incr%:NEXT lp%:EXIT lp% : REMark don't move too low
5070     new_pos%=pos%(lp%)+dir%(lp%)
5080     IF pos%(lp%)>0 AND dir%(lp%)=-incr%:pos%(lp%)=new_pos%:NEXT lp%:EXIT lp%
5090     IF new_pos%<-16:dir%(lp%)=incr%:new_pos%=new_pos%+incr% : REMark change direction
5100     pos%(lp%)=new_pos%
5110     WINDOW#cv_gamechan%,cv_spxsz%,cv_spysz%*2+8,start_x%+lp%*cv_spxsz%,start_y%-8
5120     SCROLL#cv_gamechan%,dir%(lp%)
5130   END FOR lp%
5140 END DEFine move_title
5150 :
5160 DEFine PROCedure anim_open (number%)
5170 REMark animate cave opening. I shoud play a sound here
5180 LOCal lp%,xo%,yo%,wall_sprite,already_set%(1),count%,nbr%,temp%,lp2%,sprt%,mycols%,tt%,interval%,id
5190   set_wdw 0
5200   IF cv_no_eye_candy%:RETurn
5210   CLS #cv_gamechan%
5220   wall_sprite = BD_SPRT(cv_madd,4)
5230   interval%=cv_col_end%-cv_col_start%
5240   FOR yo%=cv_spysz% TO 22*cv_spysz% STEP cv_spysz%
5250     FOR xo%=0 TO interval%*cv_spxsz% STEP cv_spxsz%
5260       PUT_AREA#cv_gamechan%,wall_sprite,xo%,yo%,cv_spxsz%,cv_spysz% : REMark draw border
5270     END FOR xo%
5280   END FOR yo%
5290   id = BD_SNDF(65536+MACHINE,HOME_DIR$&"snd_cover_ub")
5300   nbr%=LEN(cv_cave_descrs$(number%))
5310   temp%=2
5320   xo%=cv_winxsz%-(nbr%*12)
5330   IF xo%<0:temp%=1:xo%=cv_winxsz%-(nbr%*8)
5340   IF xo%<0:temp%=0:xo%=0
5350   xo%=xo% DIV 2
5360   CSIZE#cv_gamechan%,temp%,0
5370   INK#cv_gamechan%,7
5380   CURSOR#cv_gamechan%,xo%,0:PRINT#cv_gamechan%,cv_cave_descrs$(number%)
5390   WAIT 20                                  : REMark show fully closed cave
5400   interval%=interval%+1
5410   count%=22*interval%
5420   temp%=count%-1
5430   DIM already_set%(count%)
5440   REPeat lp%
5450     nbr%=RND(0 TO temp%)
5460     IF already_set%(nbr%):NEXT lp%
5470     already_set%(nbr%)=1
5480     yo%=(nbr% DIV interval%)+1
5490     xo%=(nbr% MOD interval%)+1
5500     sprt%=cv_data%(number%,yo%,xo%+cv_col_start%)
5510     xo%=xo%-1
5520     IF sprt%<>7
5530       IF sprt%=0:sprt%=4                   : REMark diggeridoo -> steel wall
5540       PUT_AREA#cv_gamechan%,BD_SPRT(cv_madd,sprt%),xo%*cv_spxsz%,yo%*cv_spysz%,cv_spxsz%,cv_spysz%
5550     ELSE
5560       BLOCK#cv_gamechan%,cv_spxsz%,cv_spysz%,xo%*cv_spxsz%,yo%*cv_spysz%,0
5570     END IF
5580     already_set%(nbr%)=1
5590     count%=count%-1
5600     IF count%=0:EXIT lp%
5610     IF MACHINE=18:NEXT lp%
5620     FOR lp2%=1 TO cv_speed%
5630       tt%=KEYROW(1):IF tt%:EXIT lp2%    : REMark keep space pressed to make this faster
5640     END FOR lp2%
5650   END REPeat lp%
5660   BD_SKILL id
5670   PAUSE 2
5680   AT#cv_gamechan%,0,0:CLS#cv_gamechan%,3
5690 END DEFine anim_open
5700 :
5710 REMark -------------------------------------------------------------
5720 REMark
5730 REMark Utility routines
5740 REMark
5750 REMark -------------------------------------------------------------
5760 :
5770 DEFine FuNction get_menu_choice$ (array$,size%,start_row%,inkk%,sel_ink%)
5780 REMark propose a scrollable menu
5790 REMark array$ contains the menu choices, size% = last element in that array to
5800 REMark be displayed
5810 REMark return the name of the menu choice selected with enter
5820 LOCal lp%,start%,end%,current%,tot%,row%,maxrows%,choice%
5830   REMark set_wdw 1
5840   WINDOW#cv_gamechan%,cv_winxsz%-2*cv_spxsz%,cv_winysz%-start_row%*20-20-cv_spysz%, cv_spxsz%+(cv_scr_xlim% - cv_winxsz%)DIV 2,start_row%*20+20+(cv_scr_ylim% - cv_winysz%) DIV 2
5850   maxrows%=15-start_row%                   : REMark max nbrs of rows in wdw
5860   end%=size% :IF size%>maxrows%:end%=maxrows%
5870   current%=0:start%=0
5880   CSIZE#cv_gamechan%,2,1
5890   INK#cv_gamechan%,inkk%
5900   display_menu
5910   REPeat lp%
5920     choice%=CODE(INKEY$(#cv_gamechan%,-1))
5930     SELect ON choice%
5940       =10  : RETurn array$(current%)
5950       =27  : RETurn ""
5960       =208 : IF current%>0
5970                 BD_SOUND cv_madd,0
5980                 current%=current%-1
5990                 IF current%<start%
6000                    SCROLL#cv_gamechan%,20
6010                    start%=start%-1 :end%=end%-1
6020                 END IF
6030                 display_menu
6040              ELSE
6050                 BD_SOUND cv_madd,12
6060              END IF
6070       =216 : IF current%<end%+1
6080                 current%=current%+1
6090                 IF current%>size%
6100                    current%=size%
6110                    BD_SOUND cv_madd,12
6120                    NEXT lp%             : REMark premature next loop
6130                 END IF
6140                 BD_SOUND cv_madd,0
6150                 IF current%>end%
6160                    SCROLL#cv_gamechan%,-20
6170                    start%=start%+1 :end%=end%+1
6180                 END IF
6190                 display_menu
6200              ELSE
6210                 BD_SOUND cv_madd,12
6220              END IF
6230     END SELect
6240   END REPeat lp%
6250 END DEFine get_menu_choice$
6260 :
6270 DEFine PROCedure display_menu
6280 REMark display a menu
6290 REMark all non local variables are from caller
6300 LOCal lp%
6310   row%=0
6320   FOR lp%=start% TO end%
6330     AT#cv_gamechan%, row%,10
6340     IF lp%=current%
6350       INK#cv_gamechan%,sel_ink%
6360       PRINT#cv_gamechan%,array$(lp%)
6370       INK#cv_gamechan%,inkk%
6380     ELSE
6390       PRINT#cv_gamechan%,array$(lp%)
6400     END IF
6410     row%=row%+1
6420   END FOR lp%
6430   CLS#cv_gamechan%,2
6440 END DEFine display_menu
6450 :
6460 DEFine FuNction checkHz%
6470 REMark are we in a 50 or 60 Hz country? & other calibration data
6480 LOCal lp%,t,temp%,count%,old%
6490   t=DATE
6500   temp%=0
6510   REPeat lp%
6520     IF t<> DATE:EXIT lp%
6530   END REPeat lp%
6540   TMR_SET cv_timer_addr
6550   t=DATE
6560   REPeat lp%
6570     IF temp%<>TMR_CHECK(cv_timer_addr): count%=count%+1:temp%=TMR_CHECK(cv_timer_addr)
6580     IF t<>DATE:EXIT lp%
6590   END REPeat lp%
6600   IF (count%)>54
6610     count%=6
6620   ELSE
6630     count%=5
6640   END IF
6650   cv_speed% = 0
6660   timer_stop
6670   timer_start
6680   TMR_SET cv_timer_addr
6690   REPeat lp%
6700     IF 0<>TMR_CHECK(cv_timer_addr): EXIT lp%
6710     cv_speed%=cv_speed%+1
6720   END REPeat lp%
6730   IF MACHINE=17
6740     cv_speed%=cv_speed% DIV 5
6750   ELSE
6760     cv_speed%=cv_speed% DIV 3
6770   END IF
6780   RETurn count%
6790 END DEFine checkHz%
6800 :
6810 DEFine PROCedure set_wdw (draw_bord%)
6820 REMark set the games window. If draw_bord%=1 : set a steelwall border around it
6830 REMark if draw_bord%=2 ; set wdw to inside that border
6840 LOCal lp%,wall_sprite,yo%,interval%
6850   cv_xo%=(cv_scr_xlim% - cv_winxsz%)DIV 2:cv_yo%=16+((cv_scr_ylim% - cv_winysz%-16) DIV 2)
6860   cv_xs%=cv_winxsz%:cv_ys%=cv_winysz%
6870   interval%=cv_col_end%-cv_col_start%
6880   WINDOW#cv_gamechan%,cv_xs%,cv_ys%, cv_xo%,cv_yo%
6890   IF draw_bord%
6900     CLS#cv_gamechan%
6910     wall_sprite = BD_SPRT(cv_madd,4)
6920     FOR lp%=0 TO interval%:PUT_AREA #cv_gamechan%,wall_sprite,lp%*cv_spxsz%,0,cv_spxsz%,cv_spysz%
6930     yo%=22*cv_spysz%
6940     FOR lp%=0 TO interval%:PUT_AREA #cv_gamechan%,wall_sprite,lp%*cv_spxsz%,yo%,cv_spxsz%,cv_spysz%
6950     FOR lp%=0 TO 22:PUT_AREA #cv_gamechan%,wall_sprite,0,lp%*cv_spysz%,cv_spxsz%,cv_spysz%
6960     yo%=interval%*cv_spxsz%
6970     FOR lp%=0 TO 22:PUT_AREA #cv_gamechan%,wall_sprite,yo%,lp%*cv_spysz%,cv_spxsz%,cv_spysz%
6980   END IF
6990   IF draw_bord%=2
7000     cv_xo%=cv_xo%+cv_spxsz%:cv_yo%=cv_yo%+cv_spysz%
7010     cv_xs%=cv_xs%-2*cv_spxsz%
7020     cv_ys%=cv_ys%-2*cv_spysz%
7030     WINDOW#cv_gamechan%,cv_xs%,cv_ys%, cv_xo%,cv_yo%
7040   END IF
7050 END DEFine set_wdw
7060 :
7070 DEFine PROCedure wait_no_key_down
7080 REMark wait until user stops pressing a key
7090 LOCal lp%
7100   REPeat lp%:IF INKEY$(#cv_gamechan%,0)="":EXIT lp%
7110   REPeat lp%:IF KEYROW(1)=0:EXIT lp%
7120 END DEFine wait_no_key_down
7130 :
7140 DEFine PROCedure timer_start
7150 REMark start the timer
7160   IF cv_timer_addr:timer_stop
7170   cv_timer_addr=TMR_USE
7180 END DEFine timer_use
7190 :
7200 DEFine PROCedure timer_stop
7210 REMark stop the timer, set cv_timer_addr to 0
7220   IF cv_timer_addr
7230     cv_timer_addr=TMR_FREE (cv_timer_addr)
7240     cv_timer_addr=0
7250   END IF
7260 END DEFine timer_stop
7270 :
7280 DEFine PROCedure sa
7290   SAVE_O win1_basic_boulder_boulder_bas
7300 END DEFine sa
7310 :
